Package org.jfree.report.modules.gui.swing.common

## Class AbstractExportDialog

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - java.awt.Window
      - - java.awt.Dialog
        - - javax.swing.JDialog
          - - org.jfree.report.modules.gui.swing.common.AbstractExportDialog

- All Implemented Interfaces:
    `java.awt.image.ImageObserver`, `java.awt.MenuContainer`, `java.io.Serializable`, `javax.accessibility.Accessible`, `javax.swing.RootPaneContainer`, `javax.swing.WindowConstants`, `ExportDialog`
  Direct Known Subclasses:
    `HtmlFileExportDialog`, `HtmlZipExportDialog`, `PdfExportDialog`

      public abstract class AbstractExportDialog
      extends javax.swing.JDialog
      implements ExportDialog

  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class javax.swing.JDialog

      `javax.swing.JDialog.AccessibleJDialog`

    - ### Nested classes/interfaces inherited from class java.awt.Dialog

      `java.awt.Dialog.AccessibleAWTDialog, java.awt.Dialog.ModalExclusionType, java.awt.Dialog.ModalityType`

    - ### Nested classes/interfaces inherited from class java.awt.Window

      `java.awt.Window.AccessibleAWTWindow, java.awt.Window.Type`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `java.awt.Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

  - ### Field Summary

    - ### Fields inherited from class javax.swing.JDialog

      `accessibleContext, rootPane, rootPaneCheckingEnabled`

    - ### Fields inherited from class java.awt.Dialog

      `DEFAULT_MODALITY_TYPE`

    - ### Fields inherited from class java.awt.Component

      `BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

    - ### Fields inherited from interface javax.swing.WindowConstants

      `DISPOSE_ON_CLOSE, DO_NOTHING_ON_CLOSE, EXIT_ON_CLOSE, HIDE_ON_CLOSE`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AbstractExportDialog()` | Creates a non-modal dialog without a title and without a specified `Frame` owner.
    `AbstractExportDialog​(java.awt.Dialog owner)` | Creates a non-modal dialog without a title with the specified `Dialog` as its owner.
    `AbstractExportDialog​(java.awt.Frame owner)` | Creates a non-modal dialog without a title with the specified `Frame` as its owner.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `abstract void` | `clear()` |
    `protected javax.swing.Action` | `getCancelAction()` |
    `protected abstract java.lang.String` | `getConfigurationPrefix()` |
    `protected abstract java.lang.String` | `getConfigurationSuffix()` |
    `protected javax.swing.Action` | `getConfirmAction()` |
    `protected FormValidator` | `getFormValidator()` |
    `protected GuiContext` | `getGuiContext()` |
    `protected ReportJob` | `getReportJob()` |
    `protected abstract java.lang.String` | `getResourceBaseName()` |
    `protected java.util.ResourceBundle` | `getResources()` | Retrieves the resources for this dialog.
    `abstract JStatusBar` | `getStatusBar()` |
    `protected abstract org.pentaho.reporting.libraries.base.config.Configuration` | `grabDialogContents​(boolean full)` | Returns a new (and not connected to the default config from the job) configuration containing all properties from the dialog.
    `protected abstract void` | `initializeFromJob​(ReportJob job, GuiContext guiContext)` |
    `boolean` | `isConfirmed()` | Returns `true` if the user confirmed the selection, and `false` otherwise.
    `protected boolean` | `isFullInputStorageEnabled​(org.pentaho.reporting.libraries.base.config.Configuration config)` |
    `protected boolean` | `isInputStorageEnabled​(org.pentaho.reporting.libraries.base.config.Configuration config)` |
    `protected boolean` | `performConfirm()` |
    `boolean` | `performQueryForExport​(ReportJob reportJob, GuiContext guiContext)` | Opens the dialog to query all necessary input from the user.
    `protected abstract boolean` | `performValidate()` |
    `protected java.io.File` | `resolvePath​(java.lang.String baseDirectory)` | Resolves file names for the exports.
    `protected void` | `setCancelAction​(javax.swing.Action cancelAction)` |
    `protected void` | `setConfirmAction​(javax.swing.Action confirmAction)` |
    `protected void` | `setConfirmed​(boolean confirmed)` | Defines whether this dialog has been finished using the 'OK' or the 'Cancel' option.
    `protected abstract void` | `setDialogContents​(org.pentaho.reporting.libraries.base.config.Configuration properties)` |

    - ### Methods inherited from class javax.swing.JDialog

      `addImpl, createRootPane, dialogInit, getAccessibleContext, getContentPane, getDefaultCloseOperation, getGlassPane, getGraphics, getJMenuBar, getLayeredPane, getRootPane, getTransferHandler, isDefaultLookAndFeelDecorated, isRootPaneCheckingEnabled, paramString, processWindowEvent, remove, repaint, setContentPane, setDefaultCloseOperation, setDefaultLookAndFeelDecorated, setGlassPane, setJMenuBar, setLayeredPane, setLayout, setRootPane, setRootPaneCheckingEnabled, setTransferHandler, update`

    - ### Methods inherited from class java.awt.Dialog

      `addNotify, getModalityType, getTitle, hide, isModal, isResizable, isUndecorated, setBackground, setModal, setModalityType, setOpacity, setResizable, setShape, setTitle, setUndecorated, setVisible, show, toBack`

    - ### Methods inherited from class java.awt.Window

      `addPropertyChangeListener, addPropertyChangeListener, addWindowFocusListener, addWindowListener, addWindowStateListener, applyResourceBundle, applyResourceBundle, createBufferStrategy, createBufferStrategy, dispose, getBackground, getBufferStrategy, getFocusableWindowState, getFocusCycleRootAncestor, getFocusOwner, getFocusTraversalKeys, getIconImages, getInputContext, getListeners, getLocale, getModalExclusionType, getMostRecentFocusOwner, getOpacity, getOwnedWindows, getOwner, getOwnerlessWindows, getShape, getToolkit, getType, getWarningString, getWindowFocusListeners, getWindowListeners, getWindows, getWindowStateListeners, isActive, isAlwaysOnTop, isAlwaysOnTopSupported, isAutoRequestFocus, isFocusableWindow, isFocusCycleRoot, isFocused, isLocationByPlatform, isOpaque, isShowing, isValidateRoot, pack, paint, postEvent, processEvent, processWindowFocusEvent, processWindowStateEvent, removeNotify, removeWindowFocusListener, removeWindowListener, removeWindowStateListener, reshape, setAlwaysOnTop, setAutoRequestFocus, setBounds, setBounds, setCursor, setFocusableWindowState, setFocusCycleRoot, setIconImage, setIconImages, setLocation, setLocation, setLocationByPlatform, setLocationRelativeTo, setMinimumSize, setModalExclusionType, setSize, setSize, setType, toFront`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getAlignmentX, getAlignmentY, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalPolicy, getInsets, getLayout, getMaximumSize, getMinimumSize, getMousePosition, getPreferredSize, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, print, printComponents, processContainerEvent, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusTraversalKeys, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setFont, transferFocusDownCycle, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, disable, disableEvents, dispatchEvent, enable, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphicsConfiguration, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocation, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, prepareImage, prepareImage, printAll, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, requestFocusInWindow, resize, resize, revalidate, setComponentOrientation, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeysEnabled, setForeground, setIgnoreRepaint, setLocale, setMaximumSize, setMixingCutoutShape, setName, setPreferredSize, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### AbstractExportDialog

          public AbstractExportDialog()

      Creates a non-modal dialog without a title and without a specified `Frame` owner. A shared, hidden frame will be set as the owner of the dialog.

    - #### AbstractExportDialog

          public AbstractExportDialog​(java.awt.Frame owner)

      Creates a non-modal dialog without a title with the specified `Frame` as its owner. If `owner` is `null`, a shared, hidden frame will be set as the owner of the dialog.
      Parameters:
        `owner` - the `Frame` from which the dialog is displayed

    - #### AbstractExportDialog

          public AbstractExportDialog​(java.awt.Dialog owner)

      Creates a non-modal dialog without a title with the specified `Dialog` as its owner.
      Parameters:
        `owner` - the non-null `Dialog` from which the dialog is displayed

  - ### Method Detail

    - #### getStatusBar

          public abstract JStatusBar getStatusBar()

    - #### getCancelAction

          protected javax.swing.Action getCancelAction()

    - #### setCancelAction

          protected void setCancelAction​(javax.swing.Action cancelAction)

    - #### getConfirmAction

          protected javax.swing.Action getConfirmAction()

    - #### setConfirmAction

          protected void setConfirmAction​(javax.swing.Action confirmAction)

    - #### performValidate

          protected abstract boolean performValidate()

    - #### getFormValidator

          protected FormValidator getFormValidator()

    - #### initializeFromJob

          protected abstract void initializeFromJob​(ReportJob job,
                                                    GuiContext guiContext)

    - #### getReportJob

          protected ReportJob getReportJob()

    - #### getGuiContext

          protected GuiContext getGuiContext()

    - #### performQueryForExport

          public boolean performQueryForExport​(ReportJob reportJob,
                                               GuiContext guiContext)

      Opens the dialog to query all necessary input from the user. This will not start the processing, as this is done elsewhere.
      Specified by:
        `performQueryForExport` in interface `ExportDialog`
      Parameters:
        `reportJob` - the report that should be processed.
      Returns:
        true, if the processing should continue, false otherwise.

    - #### getConfigurationPrefix

          protected abstract java.lang.String getConfigurationPrefix()

    - #### grabDialogContents

          protected abstract org.pentaho.reporting.libraries.base.config.Configuration grabDialogContents​(boolean full)

      Returns a new (and not connected to the default config from the job) configuration containing all properties from the dialog.
      Parameters:
        `full` -
      Returns:

    - #### setDialogContents

          protected abstract void setDialogContents​(org.pentaho.reporting.libraries.base.config.Configuration properties)

    - #### getConfigurationSuffix

          protected abstract java.lang.String getConfigurationSuffix()

    - #### getResources

          protected java.util.ResourceBundle getResources()

      Retrieves the resources for this dialog. If the resources are not initialized, they get loaded on the first call to this method.
      Returns:
        this frames ResourceBundle.

    - #### isInputStorageEnabled

          protected boolean isInputStorageEnabled​(org.pentaho.reporting.libraries.base.config.Configuration config)

    - #### isFullInputStorageEnabled

          protected boolean isFullInputStorageEnabled​(org.pentaho.reporting.libraries.base.config.Configuration config)

    - #### isConfirmed

          public boolean isConfirmed()

      Returns `true` if the user confirmed the selection, and `false` otherwise. The file should only be saved if the result is `true`.
      Returns:
        A boolean.

    - #### setConfirmed

          protected void setConfirmed​(boolean confirmed)

      Defines whether this dialog has been finished using the 'OK' or the 'Cancel' option.
      Parameters:
        `confirmed` - set to `true`, if OK was pressed, `false` otherwise

    - #### performConfirm

          protected boolean performConfirm()

    - #### clear

          public abstract void clear()

    - #### getResourceBaseName

          protected abstract java.lang.String getResourceBaseName()

    - #### resolvePath

          protected java.io.File resolvePath​(java.lang.String baseDirectory)

      Resolves file names for the exports. An occurence of "~/" at the beginning of the name will be replaced with the users home directory.
      Parameters:
        `baseDirectory` - the base directory as specified in the configuration.
      Returns:
        the file object pointing to that directory.
      Throws:
        `java.lang.IllegalArgumentException` - if the base directory is null.